﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Editroid
{
    public partial class ExpandoDialog : Form
    {
        public ExpandoDialog() {
            InitializeComponent();

            ShowExpandMessage();
        }

        private void ShowExpandMessage() {
            richTextBox1.Rtf = Rtf.EnhancoNotes;
            string romFormatString;
            switch (_currentRomFormat) {
                case RomFormats.Standard: romFormatString = "Unexpanded"; break;
                case RomFormats.Expando: romFormatString = "1/2 Expanded"; break;
                case RomFormats.Enhanco: romFormatString = "Expanded"; break;
                default: romFormatString = "Unknown"; break;
            }
            richTextBox1.AppendText(Environment.NewLine + Environment.NewLine + "Current ROM format: " + romFormatString);
        }

        private void btnCancel_Click(object sender, EventArgs e) {
            Hide();
            DialogResult = DialogResult.Cancel;
        }

        private void btnOX_Click(object sender, EventArgs e) {
            Hide();
            DialogResult = DialogResult.OK;
        }


        RomFormats _currentRomFormat;
        internal RomFormats CurrentRomFormat {
            get { return _currentRomFormat; }
            set {
                _currentRomFormat = value;
                OnCurrentRomFormatChanged();
            }
        }

        private void OnCurrentRomFormatChanged() {
            ShowExpandMessage();
        }
    }
}
