namespace Windows.Enum
{
    public enum SystemColor
    {

        /// <summary>Dark shadow for three-dimensional display elements.</summary> 
        Obj3dDarkShadow = 21,
        /// <summary>Face color for three-dimensional display elements and for dialog box backgrounds.</summary>
        Obj3dFace = ButtonFace,
        /// <summary>Highlight color for three-dimensional display elements.</summary>
        Obj3dHighlight = ButtonHighlight,
        /// <summary>Highlight color for three-dimensional display elements.</summary>
        Obj3dHilight = ButtonHighlight,
        /// <summary>Light color for three-dimensional display elements.</summary>
        Obj3dLight = 22,
        /// <summary>Shadow color for three-dimensional display elements.</summary>
        Obj3dShadow = ButtonShadow,
        /// <summary>Active window border.</summary>
        ActiveBarder = 10,
        /// <summary>Active window title bar. </summary>
        ActiveCaption = 2,
        /// <summary>Background color of MDI applications.</summary>
        AppWorkspace = 12,
        /// <summary>Desktop.</summary>
        Background = 1,
        /// <summary>Face color for three-dimensional display elements and for dialog box backgrounds.</summary>
        ButtonFace = 15,
        /// <summary>Highlight color for three-dimensional display elements.</summary>
        ButtonHighlight = 20,
        /// <summary>Highlight color for three-dimensional display elements.</summary>
        ButtonHilight = ButtonHighlight,
        /// <summary>Shadow color for three-dimensional display elements.</summary>
        ButtonShadow = 16,
        /// <summary>Text on push buttons.</summary>
        ButtonText = 18,
        /// <summary>Text in caption, size box, and scroll bar arrow box.</summary>
        CaptionText = 9,
        /// <summary>Desktop.</summary>
        Desktop = Background,
        /// <summary>Right side color in the color gradient of an active window's title bar. </summary>
        GradientActiveCaption = 27,
        /// <summary>Right side color in the color gradient of an inactive window's title bar. </summary>
        GradientIvactiveCaption = 28,
        /// <summary>Grayed (disabled) text.</summary>
        GrayText = 17,
        /// <summary>Item(s) selected in a control.</summary>
        Highlight = 13,
        /// <summary>Text of item(s) selected in a control.</summary>
        HighlightText = 14,
        /// <summary>Color for a hyperlink or hot-tracked item.</summary>
        HotLight = 26,
        /// <summary>Inactive window border.</summary>
        InactiveBorder = 11,
        /// <summary>Inactive window caption.</summary>
        InactiveCaption = 3,
        /// <summary>Color of text in an inactive caption.</summary>
        InactiveCaptionText = 19,
        /// <summary>Background color for tooltip controls.</summary>
        InfoBg = 24,
        /// <summary>Text color for tooltip controls.</summary>
        InfoText = 23,
        /// <summary>Menu background.</summary>
        Menu = 4,
        /// <summary>The color used to highlight menu items when the menu appears as a flat menu.</summary>
        MenuHilight = 29,
        /// <summary>The background color for the menu bar when menus appear as flat menus.</summary>
        MenuBar = 30,
        /// <summary>Text in menus.</summary>
        MenuText = 7,
        /// <summary>Scroll bar gray area.</summary>
        ScrollBar = 0,
        /// <summary>Window background.</summary>
        Window = 5,
        /// <summary>Window frame.</summary>
        WindowFrame = 6,
        /// <summary>Text in windows.</summary>
        WindowText = 8
    }
}