using System;
using System.Collections.Generic;
using System.Text;

namespace Windows
{
    public enum WindowsMessage : int
    {
        Activate = 0x6,
        ActivateApplication = 0x1C,
        ADSPROP_NOTIFY_APPLY = (User + 1104),
        ADSPROP_NOTIFY_CHANGE = (User + 1103),
        ADSPROP_NOTIFY_ERROR = (User + 1110),
        ADSPROP_NOTIFY_EXIT = (User + 1107),
        ADSPROP_NOTIFY_FOREGROUND = (User + 1106),
        ADSPROP_NOTIFY_PAGEHWND = (User + 1102),
        ADSPROP_NOTIFY_PAGEINIT = (User + 1101),
        ADSPROP_NOTIFY_SETFOCUS = (User + 1105),
        ADSPROP_NOTIFY_SHOW_ERROR_DIALOG = (User + 1111),
        AFXFIRST = 0x360,
        AFXLAST = 0x37F,
        APP = 0x8000,
        APPCOMMAND = 0x319,
        ASKCBFORMATNAME = 0x30C,
        CANCELJOURNAL = 0x4B,
        CANCELMODE = 0x1F,
        CAP_ABORT = (CAP_START + 69),
        CAP_DLG_VIDEOCOMPRESSION = (CAP_START + 46),
        CAP_DLG_VIDEODISPLAY = (CAP_START + 43),
        CAP_DLG_VIDEOFORMAT = (CAP_START + 41),
        CAP_DLG_VIDEOSOURCE = (CAP_START + 42),
        CAP_DRIVER_CONNECT = (CAP_START + 10),
        CAP_DRIVER_DISCONNECT = (CAP_START + 11),
        CAP_DRIVER_GET_CAPS = (CAP_START + 14),
        CAP_DRIVER_GET_NAMEA = (CAP_START + 12),
        CAP_DRIVER_GET_NAMEW = (CAP_UNICODE_START + 12),
        CAP_DRIVER_GET_VERSIONA = (CAP_START + 13),
        CAP_DRIVER_GET_VERSIONW = (CAP_UNICODE_START + 13),
        CAP_EDIT_COPY = (CAP_START + 30),
        CAP_END = CAP_UNICODE_END,
        CAP_FILE_ALLOCATE = (CAP_START + 22),
        CAP_FILE_GET_CAPTURE_FILEA = (CAP_START + 21),
        CAP_FILE_GET_CAPTURE_FILEW = (CAP_UNICODE_START + 21),
        CAP_FILE_SAVEASA = (CAP_START + 23),
        CAP_FILE_SAVEASW = (CAP_UNICODE_START + 23),
        CAP_FILE_SAVEDIBA = (CAP_START + 25),
        CAP_FILE_SAVEDIBW = (CAP_UNICODE_START + 25),
        CAP_FILE_SET_CAPTURE_FILEA = (CAP_START + 20),
        CAP_FILE_SET_CAPTURE_FILEW = (CAP_UNICODE_START + 20),
        CAP_FILE_SET_INFOCHUNK = (CAP_START + 24),
        CAP_GET_AUDIOFORMAT = (CAP_START + 36),
        CAP_GET_CAPSTREAMPTR = (CAP_START + 1),
        CAP_GET_MCI_DEVICEA = (CAP_START + 67),
        CAP_GET_MCI_DEVICEW = (CAP_UNICODE_START + 67),
        CAP_GET_SEQUENCE_SETUP = (CAP_START + 65),
        CAP_GET_STATUS = (CAP_START + 54),
        CAP_GET_USER_DATA = (CAP_START + 8),
        CAP_GET_VIDEOFORMAT = (CAP_START + 44),
        CAP_GRAB_FRAME = (CAP_START + 60),
        CAP_GRAB_FRAME_NOSTOP = (CAP_START + 61),
        CAP_PAL_AUTOCREATE = (CAP_START + 83),
        CAP_PAL_MANUALCREATE = (CAP_START + 84),
        CAP_PAL_OPENA = (CAP_START + 80),
        CAP_PAL_OPENW = (CAP_UNICODE_START + 80),
        CAP_PAL_PASTE = (CAP_START + 82),
        CAP_PAL_SAVEA = (CAP_START + 81),
        CAP_PAL_SAVEW = (CAP_UNICODE_START + 81),
        CAP_SEQUENCE = (CAP_START + 62),
        CAP_SEQUENCE_NOFILE = (CAP_START + 63),
        CAP_SET_AUDIOFORMAT = (CAP_START + 35),
        CAP_SET_CALLBACK_CAPCONTROL = (CAP_START + 85),
        CAP_SET_CALLBACK_ERRORA = (CAP_START + 2),
        CAP_SET_CALLBACK_ERRORW = (CAP_UNICODE_START + 2),
        CAP_SET_CALLBACK_FRAME = (CAP_START + 5),
        CAP_SET_CALLBACK_STATUSA = (CAP_START + 3),
        CAP_SET_CALLBACK_STATUSW = (CAP_UNICODE_START + 3),
        CAP_SET_CALLBACK_VIDEOSTREAM = (CAP_START + 6),
        CAP_SET_CALLBACK_WAVESTREAM = (CAP_START + 7),
        CAP_SET_CALLBACK_YIELD = (CAP_START + 4),
        CAP_SET_MCI_DEVICEA = (CAP_START + 66),
        CAP_SET_MCI_DEVICEW = (CAP_UNICODE_START + 66),
        CAP_SET_OVERLAY = (CAP_START + 51),
        CAP_SET_PREVIEW = (CAP_START + 50),
        CAP_SET_PREVIEWRATE = (CAP_START + 52),
        CAP_SET_SCALE = (CAP_START + 53),
        CAP_SET_SCROLL = (CAP_START + 55),
        CAP_SET_SEQUENCE_SETUP = (CAP_START + 64),
        CAP_SET_USER_DATA = (CAP_START + 9),
        CAP_SET_VIDEOFORMAT = (CAP_START + 45),
        CAP_SINGLE_FRAME = (CAP_START + 72),
        CAP_SINGLE_FRAME_CLOSE = (CAP_START + 71),
        CAP_SINGLE_FRAME_OPEN = (CAP_START + 70),
        CAP_START = User,
        CAP_STOP = (CAP_START + 68),
        CAP_UNICODE_END = CAP_PAL_SAVEW,
        CAP_UNICODE_START = User + 100,
        CAPTURECHANGED = 0x215,
        CHANGECBCHAIN = 0x30D,
        CHANGEUISTATE = 0x127,
        CHAR = 0x102,
        CHARTOITEM = 0x2F,
        CHILDACTIVATE = 0x22,
        CHOOSEFONT_GETLOGFONT = (User + 1),
        CHOOSEFONT_SETFLAGS = (User + 102),
        CHOOSEFONT_SETLOGFONT = (User + 101),
        CLEAR = 0x303,
        CLOSE = 0x10,
        COMMAND = 0x111,
        COMMNOTIFY = 0x44,
        COMPACTING = 0x41,
        COMPAREITEM = 0x39,
        CONTEXTMENU = 0x7B,
        CONVERTREQUEST = 0x10A,
        CONVERTREQUESTEX = 0x108,
        CONVERTRESULT = 0x10B,
        COPY = 0x301,
        COPYDATA = 0x4A,
        CPL_LAUNCH = (User + 1000),
        CPL_LAUNCHED = (User + 1001),
        CREATE = 0x1,
        CTLCOLOR = 0x19,
        CTLCOLORBTN = 0x135,
        CTLCOLORDLG = 0x136,
        CTLCOLOREDIT = 0x133,
        CTLCOLORLISTBOX = 0x134,
        CTLCOLORMSGBOX = 0x132,
        CTLCOLORSCROLLBAR = 0x137,
        CTLCOLORSTATIC = 0x138,
        CUT = 0x300,
        DDE_ACK = (DDE_FIRST + 4),
        DDE_ADVISE = (DDE_FIRST + 2),
        DDE_DATA = (DDE_FIRST + 5),
        DDE_EXECUTE = (DDE_FIRST + 8),
        DDE_FIRST = 0x3E0,
        DDE_INITIATE = (DDE_FIRST),
        DDE_LAST = (DDE_FIRST + 8),
        DDE_POKE = (DDE_FIRST + 7),
        DDE_REQUEST = (DDE_FIRST + 6),
        DDE_TERMINATE = (DDE_FIRST + 1),
        DDE_UNADVISE = (DDE_FIRST + 3),
        DEADCHAR = 0x103,
        DELETEITEM = 0x2D,
        DESTROY = 0x2,
        DESTROYCLIPBOARD = 0x307,
        DEVICECHANGE = 0x219,
        DEVMODECHANGE = 0x1B,
        DISPLAYCHANGE = 0x7E,
        DRAWCLIPBOARD = 0x308,
        DRAWITEM = 0x2B,
        DROPFILES = 0x233,
        ENABLE = 0xA,
        ENDSESSION = 0x16,
        ENTERIDLE = 0x121,
        ENTERMENULOOP = 0x211,
        ENTERSIZEMOVE = 0x231,
        ERASEBKGND = 0x14,
        EXITMENULOOP = 0x212,
        EXITSIZEMOVE = 0x232,
        FONTCHANGE = 0x1D,
        FORWARDMSG = 0x37F,
        GETDLGCODE = 0x87,
        GetFont = 0x31,
        GetHotkey = 0x33,
        GetIcon = 0x7F,
        GetMinMaxInfo = 0x24,
        GetObject = 0x3D,
        GetText = 0xD,
        GetTextLength = 0xE,
        HANDHELDFIRST = 0x358,
        HANDHELDLAST = 0x35F,
        HELP = 0x53,
        HOTKEY = 0x312,
        HSCROLL = 0x114,
        HSCROLLCLIPBOARD = 0x30E,
        ICONERASEBKGND = 0x27,
        IME_CHAR = 0x286,
        IME_COMPOSITION = 0x10F,
        IME_COMPOSITIONFULL = 0x284,
        IME_CONTROL = 0x283,
        IME_ENDCOMPOSITION = 0x10E,
        IME_KEYDOWN = 0x290,
        IME_KEYLAST = 0x10F,
        IME_KEYUP = 0x291,
        IME_NOTIFY = 0x282,
        IME_REPORT = 0x280,
        IME_REQUEST = 0x288,
        IME_SELECT = 0x285,
        IME_SETCONTEXT = 0x281,
        IME_STARTCOMPOSITION = 0x10D,
        IMEKEYDOWN = 0x290,
        IMEKEYUP = 0x291,
        INITDIALOG = 0x110,
        INITMENU = 0x116,
        INITMENUPOPUP = 0x117,
        INPUTLANGCHANGE = 0x51,
        INPUTLANGCHANGEREQUEST = 0x50,
        INTERIM = 0x10C,
        KEYDOWN = 0x100,
        KEYFIRST = 0x100,
        KEYLAST = 0x108,
        KEYUP = 0x101,
        KILLFOCUS = 0x8,
        LBUTTONDBLCLK = 0x203,
        LBUTTONDOWN = 0x201,
        LBUTTONUP = 0x202,
        MBUTTONDBLCLK = 0x209,
        MBUTTONDOWN = 0x207,
        MBUTTONUP = 0x208,
        MdiActivate = 0x222,
        MdiCascade = 0x227,
        MdiCreate = 0x220,
        MdiDestroy = 0x221,
        MdiGetActive = 0x229,
        MdiIconArrange = 0x228,
        MdiMaximize = 0x225,
        MdiNext = 0x224,
        MdiRefreshMenu = 0x234,
        MdiRestore = 0x223,
        MdiSetTitle = 0x230,
        MdiTitle = 0x226,
        MeasureItem = 0x2C,
        MenuChar = 0x120,
        MenuCommand = 0x126,
        MenuDrag = 0x123,
        MenuGetObject = 0x124,
        MenuRightButtonUp = 0x122,
        MenuSelect = 0x11F,
        MouseActivate = 0x21,
        MouseFirst = 0x200,
        MouseHover = 0x2A1,
        MouseLast = 0x209,
        MouseLeave = 0x2A3,
        MouseMove = 0x200,
        MouseWheel = 0x20A,
        Move = 0x3,
        Moving = 0x216,
        NCACTIVATE = 0x86,
        NCCALCSIZE = 0x83,
        NCCREATE = 0x81,
        NCDESTROY = 0x82,
        NCHITTEST = 0x84,
        NCLBUTTONDBLCLK = 0xA3,
        NCLBUTTONDOWN = 0xA1,
        NCLBUTTONUP = 0xA2,
        NCMBUTTONDBLCLK = 0xA9,
        NCMBUTTONDOWN = 0xA7,
        NCMBUTTONUP = 0xA8,
        NCMOUSEHOVER = 0x2A0,
        NCMOUSELEAVE = 0x2A2,
        NCMOUSEMOVE = 0xA0,
        NCPAINT = 0x85,
        NCRBUTTONDBLCLK = 0xA6,
        NCRBUTTONDOWN = 0xA4,
        NCRBUTTONUP = 0xA5,
        NCXBUTTONDBLCLK = 0xAD,
        NCXBUTTONDOWN = 0xAB,
        NCXBUTTONUP = 0xAC,
        NextDialogCtl = 0x28,
        NextMenu = 0x213,
        Notify = 0x4E,
        NotifyFormat = 0x55,
        Null = 0x0,
        OtherWindowCreated = 0x42,
        OtherWindowDestroyed = 0x43,
        Paint = 0xF,
        PaintClipboard = 0x309,
        PaintIcon = 0x26,
        PaletteChanged = 0x311,
        PaletteIsChanging = 0x310,
        ParentNotify = 0x210,
        Paste = 0x302,
        PenWinFirst = 0x380,
        PenWinLast = 0x38F,
        Power = 0x48,
        PowerBroadcast = 0x218,
        Print = 0x317,
        PrintClient = 0x318,
        PSD_ENVSTAMPRECT = (User + 5),
        PSD_FULLPAGERECT = (User + 1),
        PSD_GREEKTEXTRECT = (User + 4),
        PSD_MARGINRECT = (User + 3),
        PSD_MINMARGINRECT = (User + 2),
        PSD_PAGESETUPDLG = (User),
        PSD_YAFULLPAGERECT = (User + 6),
        QueryDragIcon = 0x37,
        QueryEndSession = 0x11,
        QueryNewPalette = 0x30F,
        QueryOpen = 0x13,
        QueryUIState = 0x129,
        QueueSync = 0x23,
        Quit = 0x12,
        RASDIALEVENT = 0xCCCD,
        RightButtonDoubleClick = 0x206,
        RightButtonDown = 0x204,
        RightButtonUp = 0x205,
        RenderAllFormats = 0x306,
        RenderFormat = 0x305,
        SetCursor = 0x20,
        SetFocus = 0x7,
        SetFont = 0x30,
        SetHotkey = 0x32,
        SetIcon = 0x80,
        SetRedraw = 0xB,
        SetText = 0xC,
        SettingsChange = WinIniChange,
        ShowWindow = 0x18,
        Size = 0x5,
        SizeClipped = 0x30B,
        Sizing = 0x214,
        SpoolerStatus = 0x2A,
        StyleChanged = 0x7D,
        StyleChanging = 0x7C,
        SyncPaint = 0x88,
        SystemChar = 0x106,
        SystemColorChange = 0x15,
        SystemCommand = 0x112,
        SystemDeadCharacter = 0x107,
        SystemKeyDown = 0x104,
        SystemKeyUp = 0x105,
        TCARD = 0x52,
        TimeChange = 0x1E,
        Timer = 0x113,
        Undo = 0x304,
        UninitMenuPopup = 0x125,
        UpdateUIState = 0x128,
        User = 0x400,
        UserChanged = 0x54,
        VKEYTOITEM = 0x2E,
        VScroll = 0x115,
        VScrollClipboard = 0x30A,
        WindowsPositionChanged = 0x47,
        WindowPositionChanging = 0x46,
        WinIniChange = 0x1A,
        WNT_CONVERTREQUESTEX = 0x109,
        XButtonDoubleClick = 0x20D,
        XButtonDown = 0x20B,
        XButtonUp = 0x20C
    }
}
