﻿////using System;
////using System.Collections.Generic;
////using System.Linq;
////using System.Text;
////using Romulus;

////namespace Nasm
////{
////    class ExpressionEvaluator
////    {
////        /// <summary>The storage of named values.</summary>
////        Parser ValueNamespace;
////        public ExpressionEvaluator(Parser valueNamespace) {
////            this.ValueNamespace = valueNamespace;
////        }

////        // Precedence:                          Result type

////        // Unary:       - ~ ! ++ -- < > <>      Same
////        // Binary:      & ^ |                   Widest
////        // Bit shift:   << >>                   L-hand
////        // Multiply:    * / %                   Widest
////        // Additive:    + -                     Widest
////        // Comparison:  < <= > >= == != <>      Byte
////        // Boolean:     && || ^^                Byte
////        // Assignment:  =                       R-hand

////        // Other notes:
////        // - Expression should be left-trimmed each time it is modified, so that it
////        //   may always be assumed there is no leading whitespace.

////        /// <summary>
////        /// Evaluates an expression and returns an 8- or 16-bit integer.
////        /// </summary>
////        /// <param name="expression">The expression to evaluate.</param>
////        /// <param name="sourceLine">The line the expression occurs on (used for exceptions)</param>
////        /// <returns></returns>
////        public LiteralValue EvaluateExpression(StringSection expression, int sourceLine) {
////            expression = expression.TrimLeft();

////            return ParseAssignment(expression);
////        }

////        private bool CheckOperator(ref StringSection expression, string op) {
////            if (op.Length > expression.Length) return false;

////            bool match = true; // Until proven false
////            for (int i = 0; i < op.Length; i++) {
////                match &= op[i] == expression[i];
////            }

////            // Remove matched operator
////            if (match) expression = expression.Substring(op.Length).TrimLeft();
////            return match;
////        }

////        private LiteralValue ParseAssignment(StringSection expression) {
////            return ParseBoolean(expression);
////        }
////        private LiteralValue ParseBoolean(StringSection expression) {
////            LiteralValue result = ParseComparison(ref expression);

////            while (true) {
////                if (CheckOperator(ref expression, "&&")) {
////                    LiteralValue rightHand = ParseComparison(ref expression);
////                    result = (AsBool(result) & AsBool(rightHand)) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, "||")) {
////                    LiteralValue rightHand = ParseComparison(ref expression);
////                    result = (AsBool(result) | AsBool(rightHand)) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, "^^")) {
////                    LiteralValue rightHand = ParseComparison(ref expression);
////                    result = (AsBool(result) ^ AsBool(rightHand)) ? trueValue : falseValue;
////                } else {
////                    return result;
////                }
////            }
////        }


////        private LiteralValue ParseComparison(ref StringSection expression) {
////            LiteralValue result = ParseAdditive(ref expression);

////            while (true) {
////                if (CheckOperator(ref expression, "==")) {
////                    LiteralValue rightHand = ParseAdditive(ref expression);
////                    result = (result.Value == rightHand.Value) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, ">=")) {
////                    LiteralValue rightHand = ParseAdditive(ref expression);
////                    result = (result.Value >= rightHand.Value) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, "<=")) {
////                    LiteralValue rightHand = ParseAdditive(ref expression);
////                    result = (result.Value <= rightHand.Value) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, ">")) {
////                    LiteralValue rightHand = ParseAdditive(ref expression);
////                    result = (result.Value > rightHand.Value) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, "<")) {
////                    LiteralValue rightHand = ParseAdditive(ref expression);
////                    result = (result.Value < rightHand.Value) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, "!=")) {
////                    LiteralValue rightHand = ParseAdditive(ref expression);
////                    result = (result.Value != rightHand.Value) ? trueValue : falseValue;
////                } else if (CheckOperator(ref expression, "<>")) {
////                    LiteralValue rightHand = ParseAdditive(ref expression);
////                    result = (result.Value != rightHand.Value) ? trueValue : falseValue;
////                } else {
////                    return result;
////                }
////            }
////        }

////        private LiteralValue ParseAdditive(ref StringSection expression) {
////            LiteralValue result = ParseMult(ref expression);

////            while (true) {
////                if (CheckOperator(ref expression, "+")) {
////                    LiteralValue rightHand = ParseMult(ref expression);
////                    result = MakeLiteral((int)result.Value + (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else if (CheckOperator(ref expression, "-")) {
////                    LiteralValue rightHand = ParseMult(ref expression);
////                    result = MakeLiteral((int)result.Value - (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////               } else {
////                    return result;
////                }
////            }
////        }

////        private LiteralValue ParseMult(ref StringSection expression) {
////            LiteralValue result = ParseShift(ref expression);

////            while (true) {
////                if (CheckOperator(ref expression, "*")) {
////                    LiteralValue rightHand = ParseShift(ref expression);
////                    result = MakeLiteral((int)result.Value * (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else if (CheckOperator(ref expression, "/")) {
////                    LiteralValue rightHand = ParseShift(ref expression);
////                    result = MakeLiteral((int)result.Value / (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else if (CheckOperator(ref expression, "%")) {
////                    LiteralValue rightHand = ParseShift(ref expression);
////                    result = MakeLiteral((int)result.Value % (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else {
////                    return result;
////                }
////            }
////        }

////        private LiteralValue ParseShift(ref StringSection expression) {
////            LiteralValue result = ParseBitTwiddle(ref expression);

////            // Bit-shifts do not cause overflow errors

////            while (true) {
////                if (CheckOperator(ref expression, "<<")) {
////                    LiteralValue rightHand = ParseBitTwiddle(ref expression);
////                    result = MakeLiteralUnchecked((int)result.Value << (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else if (CheckOperator(ref expression, ">>")) {
////                    LiteralValue rightHand = ParseBitTwiddle(ref expression);
////                    result = MakeLiteralUnchecked((int)result.Value >> (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else {
////                    return result;
////                }
////            }
////        }

////        private LiteralValue ParseBitTwiddle(ref StringSection expression) {
////            LiteralValue result = ParseUnary(ref expression);

////            while (true) {
////                if (CheckOperator(ref expression, "&")) {
////                    LiteralValue rightHand = ParseUnary(ref expression);
////                    result = MakeLiteral((int)result.Value & (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else if (CheckOperator(ref expression, "|")) {
////                    LiteralValue rightHand = ParseUnary(ref expression);
////                    result = MakeLiteral((int)result.Value | (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else if (CheckOperator(ref expression, "^")) {
////                    LiteralValue rightHand = ParseUnary(ref expression);
////                    result = MakeLiteral((int)result.Value ^ (int)rightHand.Value, result.IsByte & rightHand.IsByte);
////                } else {
////                    return result;
////                }
////            }
////        }

////        private LiteralValue ParseUnary(ref StringSection expression) {
////            if (CheckOperator(ref expression, "+")) {
////                // Unary + operator is a nop
////                return ParseUnary(ref expression);
////            } else if (CheckOperator(ref expression, "-")) {
////                LiteralValue result = ParseUnary(ref expression);
////                return MakeLiteral(-(int)result.Value, result.IsByte);
////            } else if (CheckOperator(ref expression, "!")) {
////                LiteralValue result = ParseUnary(ref expression);
////                return AsBool(result) ? falseValue : trueValue;
////            } else if (CheckOperator(ref expression, "++")) {
////                StringSection lValue = GetLValue(ref expression);
////                LiteralValue value = GetSymbolValue(lValue);
////                value = MakeLiteral((int)value.Value + 1, value.IsByte);
////                SetSymbolValue(lValue, value);
////                return value;
////            } else if (CheckOperator(ref expression, "--")) {
////                StringSection lValue = GetLValue(ref expression);
////                LiteralValue value = GetSymbolValue(lValue);
////                value = MakeLiteral((int)value.Value - 1, value.IsByte);
////                SetSymbolValue(lValue, value);
////                return value;
////            } else if (CheckOperator(ref expression, "<>")) {
////                LiteralValue result = ParseUnary(ref expression);
////                return MakeLiteralUnchecked(result.Value, false);
////            } else if (CheckOperator(ref expression, "<")) {
////                LiteralValue result = ParseUnary(ref expression);
////                return MakeLiteralUnchecked(result.Value, true);
////            } else if (CheckOperator(ref expression, ">")) {
////                LiteralValue result = ParseUnary(ref expression);
////                return MakeLiteralUnchecked(result.Value >> 8, true);
////            } else if (CheckOperator(ref expression, "~")) {
////                LiteralValue result = ParseUnary(ref expression);
////                return MakeLiteralUnchecked(~(int)result.Value, false);
////            } else {
////                return ParseValue(ref expression);
////            }
////        }

////        private LiteralValue ParseValue(ref StringSection expression) {
////            if (expression.IsNullOrEmpty) throw new PrivateExpectedValueException();

////            if (expression[0] == '$') {
////                expression = expression.Substring(1); // Remove $
////                StringSection hexString = GetHexString(expression);
////                if (hexString.Length == 0) throw new PrivateExpectedValueException();
////                expression = expression.Substring(hexString.Length).TrimLeft(); // Remove number
////                return ParseHex(hexString);
////            } else if (expression[0] == '%') {
////                expression = expression.Substring(1); // Remove %
////                StringSection binString = GetBinString(expression);
////                if (binString.Length == 0) throw new PrivateExpectedValueException();
////                expression = expression.Substring(binString.Length).TrimLeft(); // Remove number
////                return ParseBin(binString);
////            } else if (char.IsDigit(expression[0])) {
////                StringSection decString = GetDecString(expression);
////                if (decString.Length == 0) throw new PrivateExpectedValueException();
////                expression = expression.Substring(decString.Length).TrimLeft(); // Remove number
////                return ParseDec(decString);
////            } else if (char.IsLetter(expression[0])) {
////                StringSection lValue = GetLValue(ref expression);
////                var value = GetSymbolValue(lValue);

////                if (CheckOperator(ref expression, "++")) {
////                    value = MakeLiteral(value.Value + 1, value.IsByte);
////                    SetSymbolValue(lValue, value);
////                } else if (CheckOperator(ref expression, "--")) {
////                    value = MakeLiteral(value.Value - 1, value.IsByte);
////                    SetSymbolValue(lValue, value);
////                }

////                return value;
////            } else {
////                throw new PrivateExpectedValueException();
////            }
////        }

////        /// <summary>
////        /// Returns a StringSection containing a numeric string, or a zero-length string if there no numeric string is found.
////        /// </summary>
////        /// <param name="source"></param>
////        /// <returns></returns>
////        private StringSection GetHexString(StringSection source) {
////            int i = 0;
////            while (i < source.Length) {
////                char c = char.ToUpper(source[i]);
////                if (char.IsDigit(c) || (c >= 'A' & c <= 'F')) {
////                    i++;
////                } else {
////                    // i is first invalid char
////                    return source.Substring(0, i);
////                }
////            }

////            // Number ran to end of string
////            return source;
////        }
////        /// <summary>
////        /// Returns a StringSection containing a numeric string, or a zero-length string if there no numeric string is found.
////        /// </summary>
////        private StringSection GetDecString(StringSection source) {
////            int i = 0;
////            while (i < source.Length) {
////                if (char.IsDigit(source[i])) {
////                    i++;
////                } else {
////                    // i is first invalid char
////                    return source.Substring(0, i);
////                }
////            }

////            // Number ran to end of string
////            return source;
////        }
////        /// <summary>
////        /// Returns a StringSection containing a numeric string, or a zero-length string if there no numeric string is found.
////        /// </summary>
////        private StringSection GetBinString(StringSection source) {
////            int i = 0;
////            while (i < source.Length) {
////                char c = source[i];
////                if (c == '0' | c == '1') {
////                    i++;
////                } else {
////                    // i is first invalid char
////                    return source.Substring(0, i);
////                }
////            }

////            // Number ran to end of string
////            return source;
////        }


////        private void SetSymbolValue(StringSection name, LiteralValue value) {
////            ValueNamespace.SetValue(name, value);
////        }

////        private LiteralValue GetSymbolValue(StringSection name) {
////            return ValueNamespace.GetValue(name);
////        }

////        private StringSection GetLValue(ref StringSection expression) {
////            if (expression.Length < 1 || !char.IsLetter(expression[0]))
////                throw new PrivateExpectedLValueException();

////            int i = 1;
////            while (i < expression.Length) {
////                char c = expression[i];
////                if (char.IsLetter(c) | char.IsDigit(c)) {
////                    i++;
////                }else{
////                    var result = expression.Substring (0,i);
////                    expression = expression.Substring(i).TrimLeft();
////                    return result;
////                }
////            }
////            var tmp = expression;
////            expression = StringSection.Empty;
////            return tmp;
////        }

////        public bool TryParseSimpleValue(StringSection expression, out LiteralValue value) {
////            value = new LiteralValue();

////            if (expression[0] == '$') {
////                expression = expression.Substring(1).TrimRight();
////                var numberPart = GetHexString(expression);
////                if (numberPart.Length != expression.Length) return false;
////                value = ParseHex(numberPart);
////                return true;
////            } else if (expression[0] == '%') {
////                expression = expression.Substring(1).TrimRight();
////                var numberPart = GetBinString(expression);
////                if (numberPart.Length != expression.Length) return false;
////                value = ParseBin(numberPart);
////                return true;
////            } else if (char.IsDigit(expression[0])) {
////                var numberPart = GetDecString(expression);
////                if (numberPart.Length != expression.Length) return false;
////                value = ParseDec(numberPart);
////                return true;
////            } else if (char.IsLetter(expression[0])) {
////                var varName = GetLValue(ref expression);
////                if (expression.Trim().Length != 0)
////                    return false;
////                //bool valueDefinedAndEvaluated = ValueNamespace.TryGetValue(varName, false, out value);
////                bool valueDefined = ValueNamespace.TryGetValue(varName, out value);
////                if (valueDefined) {
////                    return true;
////                } else {
////                    return false;
////                }

////            }
////            return false;
////        }
        
////        private static LiteralValue ParseDec(StringSection valueExpression) {
////            int value;
////            if (!int.TryParse(valueExpression.ToString(), out value))
////                throw new PrivateNumberException();
////            if (value < short.MinValue || value > ushort.MaxValue)
////                throw new PrivateNumberException();
            
////            bool isWord = (value > 255 | value < -128) || valueExpression[0] == '0';
////            return new LiteralValue((ushort)value, !isWord);
////        }

////        private static LiteralValue ParseBin(StringSection valueString) {
////            bool isByte = valueString.Length <= 8;

////            if (valueString.Length < 1 || valueString.Length > 16) 
////                throw new PrivateNumberException();
            
////            int result = 0;
////            for (int i = 0; i < valueString.Length; i++ ) {
////                result <<= 1;
////                char c = valueString[i];
////                if (c == '1')
////                    result |= 1;
////                else if (c != '0') // Not a '0' or '1', invalid.
////                    throw new PrivateNumberException();
////            }
////            return new LiteralValue((ushort)result, isByte);
////        }

////        private static LiteralValue ParseHex(StringSection valueString) {
////            bool isByte = valueString.Length <= 2;

////            int result;
////            if (!int.TryParse(valueString.ToString(), System.Globalization.NumberStyles.HexNumber, null, out result))
////                throw new PrivateNumberException();
////            if (result < short.MinValue || result > ushort.MaxValue)
////                throw new PrivateNumberException();

////            return new LiteralValue((ushort)result, isByte);
////        }
////        public Checking OverflowChecking { get; set; }

////        private static readonly LiteralValue trueValue = new LiteralValue(0xFF, true);
////        private static readonly LiteralValue falseValue = new LiteralValue(0xFF, true);
////        private static bool AsBool(LiteralValue value) {
////            if (value.IsByte)
////                return (value.Value & 0xFF) != 0;
////            else
////                return value.Value != 0;
////        }
////        /// <summary>
////        /// Creates a LiteralValue object, and performs range checking if the evaluator is so-configured.
////        /// </summary>
////        /// <param name="value"></param>
////        /// <param name="isByte"></param>
////        /// <returns></returns>
////        private LiteralValue MakeLiteral(int value, bool isByte) {
////            switch (OverflowChecking) {
////                case Checking.Unsigned:
////                    if (value < 0)
////                        throw new PrivateOverflowException();
////                    if (value > (isByte ? 0xFF : 0xFFFF))
////                        throw new PrivateOverflowException();
////                    break;
////                case Checking.Signed:
////                    if (isByte) {
////                        if (value < -128 || value > 127)
////                            throw new PrivateOverflowException();
////                    } else {
////                        if (value < -32768 || value > 32767)
////                            throw new PrivateOverflowException();
////                    }
////                    break;
////            }
////            return MakeLiteralUnchecked(value, isByte);
////        }

////        private static LiteralValue MakeLiteralUnchecked(int value, bool isByte) {
////            if (isByte) {
////                return new LiteralValue((byte)value, true);
////            } else {
////                return new LiteralValue((ushort)value, false);
////            }
////        }

////        private class PrivateException : Exception
////        {
////            public PrivateException(string message)
////                : base(message) {
////            }
////        }
////        private class PrivateOverflowException : PrivateException
////        {
////            public PrivateOverflowException()
////                : base("Expression resulted in overflow.") {
////            }
////            public PrivateOverflowException(string message)
////                : base(message) {
////            }
////        }
////        private class PrivateNumberException : PrivateException
////        {
////            public PrivateNumberException()
////                : base("Number has bad format or is out of range.") {
////            }
////            public PrivateNumberException(string message)
////                : base(message) {
////            }
////        }
////        private class PrivateExpectedLValueException : PrivateException
////        {
////            public PrivateExpectedLValueException()
////                : base("Expected: assignable variable.") {
////            }
////            public PrivateExpectedLValueException(string message)
////                : base(message) {
////            }
////        }

////        private class PrivateExpectedValueException : PrivateException
////        {
////            public PrivateExpectedValueException()
////                : base("Expected: value.") {
////            }
////            public PrivateExpectedValueException(string message)
////                : base(message) {
////            }
////        }

////        public enum Checking
////        {
////            Disabled,
////            Unsigned,
////            Signed
////        }
////    }
////}
